//-------------------------------------------------------------------
//
// konto.cpp
//
// Klasse for vedlikehold av konto.
//
class Konto {

  public:
    void    settSaldo(
              double nySaldo);  // Inn
    void    settGrense(
              double nyGrense); // Inn

    double  finnSaldo() const;
    double  finnGrense() const;
    double  finnDisponibelt() const;

    void    innskudd(
              double beloep);   // Inn
    bool	uttakOK(
              double beloep);   // Inn

  private:
    double grense;
    double saldo;
}; // Konto

//-------------------------------------------------------------------
//
// konto1.cpp forts.
//
//-------------------------------------------------------------------
void Konto::settSaldo(double nySaldo)
{
  saldo = nySaldo;
} // settSaldo

//-------------------------------------------------------------------
void Konto::settGrense(double nyGrense)
{
  grense = nyGrense;
} // settGrense

//-------------------------------------------------------------------
double Konto::finnSaldo() const
{
  return saldo;
} // finnSaldo

//-------------------------------------------------------------------
double Konto::finnGrense() const
{
  return grense;
} // finnGrense

//-------------------------------------------------------------------
double Konto::finnDisponibelt() const
{
  return grense + saldo;
} // finnDisponibelt

//-------------------------------------------------------------------
void Konto::innskudd(double beloep) 
{
  saldo += beloep;
} // innskudd

//-------------------------------------------------------------------
bool Konto::uttakOK(double beloep)
{
  if (saldo + grense < beloep) {
    return false;
    }
  else {
    saldo -= beloep;
    return true;
    }
} // uttakOK
