//-------------------------------------------------------------------
//
// konto_hoved.cpp
//
// Program for  vedlikeholde Eva sin konto.   
// Programmet gr i lkke og lar bruker velge transaksjonstype
// (sett ny kredittgrense, innskudd, uttak) fra en meny.
//

#include <iostream>
#include <iomanip>
#include <string>                                   
#include "op10_3.cpp"
using namespace std;

// Konstanter knyttet til menyvalget
const string menytekst = "S: Sett ny kredittgrense.\n"
                         "I: Innskudd.\n"
                         "U: Uttak.\n"
                         "A: Avslutt.\n";
const string lovligValg = "SIUA"; 
enum valg {nyGrense, inn, ut, slutt}; 

int  lesMenyvalg(string menytekst, string lovligValg); 

int main()
{                           
  Konto evaSinKonto;
  evaSinKonto.settGrense(0.0);    // Nullstilling av kontoen
  evaSinKonto.settSaldo(0.0);

  KontoBgs bgs; // brukergrensesnitt mot konto-objektet
  bgs.settKonto(evaSinKonto);

  valg valget = (valg)lesMenyvalg(menytekst, lovligValg);
  while (valget != slutt) {
    if (valget == nyGrense) bgs.endreKredittgrense();
    else if (valget == inn) bgs.foretaInnskudd();
    else if (valget == ut) bgs.foretaUttak();
    bgs.skrivKontoOpplysninger();
    valget = (valg)lesMenyvalg(menytekst, lovligValg);
  } // while
  return 0;
} // main


//-------------------------------------------------------------------
//
// Funksjon som skriver en menytekst p skjermen, 
// og leser brukers valg. Hvis bruker skriver et ulovlig tegn, 
// ber funksjonen om et nytt tegn.
// Bde stor og liten bokstav godtas.
// Returverdien forteller hvilket tegnnummer som ble valgt.
//                 

int lesMenyvalg(
  string menytekst,    // Inn
  string lovligValg)   // Inn  
{
  char valg;
  cout << endl << menytekst << endl << "Skriv et av tegnene " 
       << lovligValg << ": ";
  cin >> valg;
    
  int indeks;
  bool lovlig = false;
  while (!lovlig) {
    indeks = lovligValg.find(toupper(valg));
    if (indeks == string::npos) indeks = lovligValg.find(tolower(valg));
    if (indeks != string::npos) lovlig = true;
    else { // verken stor eller liten bokstav er funnet
      cout << "Ulovlig valg - skriv " << lovligValg << " : ";
      cin >> valg;
      } 
    }                             
  return indeks;
} // lesMenyvalg
