//-------------------------------------------------------------------
//
// navn.cpp
//
// Klasse for  hndtere personnavn. 
// Klientprogrammet oppgir navnet som en tekststreng.
// Klassen forutsetter at navnet bestr av minst to ord.
// 
#include <sstream>
#include <string>
using namespace std;
class Navn {         
  
  public:
    void   settNavn(
             string nyttNavn);		// Inn, minst to ord
    void   settFornavn(
             string nyttFornavn);    // Inn
    void   settMellomnavn(
             string nyttMellomnavn); // Inn
    void   settEtternavn(
             string nyttEtternavn);  // Inn       

    string finnFornavn() const;
    string finnEtternavn() const;
    string finnMellomnavn() const;
    string finnNavn() const;
    
  private:
    string fornavn;
    string mellomnavn;
    string etternavn;
  }; // Navn

//-------------------------------------------------------------------
void Navn::settNavn(string nyttNavn)
{
  // Deler opp navnet i tre deler 
  // Frst fornavnet
  int forsteBlank = nyttNavn.find(' ');
  fornavn = nyttNavn.substr(0, forsteBlank);
  
  // S mellomnavnet
  int sisteBlank = nyttNavn.rfind(' ');
  if (forsteBlank == sisteBlank) mellomnavn = "";
  else {
    int lengdeMellomnavn = sisteBlank - forsteBlank - 1;
    mellomnavn = nyttNavn.substr(forsteBlank + 1, lengdeMellomnavn);
    }

  // S etternavnet
  int lengdeEtternavn = nyttNavn.length() - sisteBlank - 1;
  etternavn = nyttNavn.substr(sisteBlank + 1, lengdeEtternavn);
} // settNavn

//-------------------------------------------------------------------
void Navn::settFornavn(string nyttFornavn)
{
  fornavn = nyttFornavn;
} // settFornavn

//-------------------------------------------------------------------
void Navn::settMellomnavn(string nyttMellomnavn)
{
  mellomnavn = nyttMellomnavn;
} // settMellomnavn

//-------------------------------------------------------------------
void Navn::settEtternavn(string nyttEtternavn)
{
  etternavn = nyttEtternavn;
} // settEtternavn

//-------------------------------------------------------------------
string Navn::finnFornavn() const
{
  return fornavn;
} // finnFornavn

//-------------------------------------------------------------------
string Navn::finnEtternavn() const
{
  return etternavn;
} // finnEtternavn

//-------------------------------------------------------------------
string Navn::finnMellomnavn() const
{  
  return mellomnavn;
} // finnMellomnavn

//-------------------------------------------------------------------
string Navn::finnNavn() const
{  
  return fornavn + " " + mellomnavn + " " + etternavn;
} // finnNavn
