//-------------------------------------------------------------------
//
// op10_3.cpp
//
// Program for  vedlikeholde Eva sin konto.   
// Programmet gr i lkke og lar bruker velge transaksjonstype
// (sett ny kredittgrense, innskudd, uttak) fra en meny.
//

#include <iostream>
#include <iomanip>
#include <string>                                   
#include "konto.cpp"
using namespace std;

void skrivFlyttall(double tall, int presisjon, int feltvidde);

const int antDes = 2;  // Kronebelp skrives ut med 2 desimaler

class KontoBgs {
  
  public:
    void settKonto(
           Konto nyKonto); // Inn
    void endreKredittgrense();   
    void foretaInnskudd();
    void foretaUttak();
    void skrivKontoOpplysninger() const;

  private:
    Konto kontoen;
}; // KontoBgs

void KontoBgs::settKonto(Konto nyKonto)
{
 kontoen = nyKonto;
} // settKonto

void KontoBgs::endreKredittgrense()
{
  cout << "Ny kredittgrense: ";
  double nyGrense;
  cin >> nyGrense;
  kontoen.settGrense(nyGrense);
} // endreKredittgrense

void KontoBgs::foretaInnskudd()
{
  cout << "Innskudd: ";
  double beloep;
  cin >> beloep;
  kontoen.innskudd(beloep);
} // foretaInnskudd

void KontoBgs::foretaUttak()
{
  cout << "Uttak: ";
  double beloep;
  cin >> beloep;
  if (!kontoen.uttakOK(beloep)) {
    double maks = kontoen.finnDisponibelt();
    cout << "For stort uttak. Disponibelt : ";
    skrivFlyttall(maks, antDes, 0);
    cout << endl;
   }
} // foretaUttak

void KontoBgs::skrivKontoOpplysninger() const       
{
  double saldo = kontoen.finnSaldo();
  double grense = kontoen.finnGrense();
  double disp = kontoen.finnDisponibelt();
  cout << "Saldo kr.: ";
  skrivFlyttall(saldo, antDes, 0);
  cout << "\nKredittgrense kr.: ";
  skrivFlyttall(grense, antDes, 0);
  cout << "\nDisponibelt belp kr.: ";
  skrivFlyttall(disp, antDes, 0);
  cout << endl;
} // skrivKontoOpplysninger     

//-------------------------------------------------------------------
//
// Funksjon for  skrive et heltall med et bestemt antall desimaler
// og en bestemt feltvidde.
// Tallet skrives p fast (ikke eksponensiell) form
//
void skrivFlyttall(double tall, int presisjon, int feltvidde)
{  
  cout << fixed << setprecision(presisjon) << showpoint << setw(feltvidde);
  cout << tall;
  cout << setprecision(6) << noshowpoint;
  cout.setf(0, ios::floatfield);
} // skrivFlyttall

/* Eksempel p kjring:

S: Sett ny kredittgrense.
I: Innskudd.
U: Uttak.
A: Avslutt.

Skriv et av tegnene SIUA: s
Ny kredittgrense: 1000
Saldo kr.: 0.00
Kredittgrense kr.: 1000.00
Disponibelt belp kr.: 1000.00

S: Sett ny kredittgrense.
I: Innskudd.
U: Uttak.
A: Avslutt.

Skriv et av tegnene SIUA: i
Innskudd: 500
Saldo kr.: 500.00
Kredittgrense kr.: 1000.00
Disponibelt belp kr.: 1500.00

S: Sett ny kredittgrense.
I: Innskudd.
U: Uttak.
A: Avslutt.

Skriv et av tegnene SIUA: u
Uttak: 200
Saldo kr.: 300.00
Kredittgrense kr.: 1000.00
Disponibelt belp kr.: 1300.00

S: Sett ny kredittgrense.
I: Innskudd.
U: Uttak.
A: Avslutt.

Skriv et av tegnene SIUA: a

*/