//-------------------------------------------------------------------
//
// direkte.cpp
//
// Program som vedlikeholder en fil med ord.
//
#include <fstream>
#include <iostream>
#include <string>

using namespace std;
                                                   
const string filnavn = "direkte.bin";
const int  maksOrdlengde = 100;
const char sluttTegn = '#';
                        
void lesNyeOrdOgSkriv(fstream &fil);
void skrivAlleOrdTilSkjermen(fstream &fil);
void forandreOrd(fstream &fil);
int main() {
  fstream fil;
  
  // Bare en allerede eksisterende fil kan pnes for lesing
  fil.open(filnavn.c_str(), ios::out | ios::in | ios::binary);
  if (!fil) { // filen eksisterer ikke, vi lager en ny
    fil.clear();
    fil.open(filnavn.c_str(), ios::out | ios::binary);
    fil.close(); // s lukker vi den og pner for bde lesing og skriving
    fil.open(filnavn.c_str(), ios::out | ios::in | ios::binary);
  }

  lesNyeOrdOgSkriv(fil);
  skrivAlleOrdTilSkjermen(fil);
  forandreOrd(fil);         
  skrivAlleOrdTilSkjermen(fil);
  fil.close();
  return 0;
} // main

//-------------------------------------------------------------------
//
// Funksjonen leser nye ord fra tastaturet.
// Disse legges etter det som ligger p filen fra fr.
//          

void lesNyeOrdOgSkriv(
  fstream &fil) {      // Inn/ut  
  
  fil.seekp(0, ios::end);  
  char ord[maksOrdlengde];
  cout << "Skriv ord. Avslutt med " << sluttTegn << endl;
  cin >> ord;                                               
  while (ord[0] != sluttTegn) {
    fil.write((char *)ord, maksOrdlengde);
    cin >> ord;
  }         
} // lesNyeOrdOgSkriv  

//-------------------------------------------------------------------  
//
// Skriver alle ordene til skjermen. Ett p hver linje nummerert fra 1.
//      
void skrivAlleOrdTilSkjermen(
  fstream &fil) {        // Inn/ut
  
  char ord[maksOrdlengde];  
  cout << "Her kommer alle ordene p filen " << filnavn << endl;
  fil.seekg(0, ios::beg);
  int ordTeller = 0;
  fil.read((char *)ord, maksOrdlengde);
  while (!fil.eof()) {
    ordTeller++;
    cout << "Ord nr. " << ordTeller << ": " << ord << endl;
    fil.read((char *)ord, maksOrdlengde);
  }
  fil.clear();
} // skrivAlleOrdTilSkjermen

//-------------------------------------------------------------------
//
// Gir brukeren muligheten til  forandre noen av ordene p filen.
//
void forandreOrd(
  fstream &fil) {      // Inn/ut                                   
  
  // Finner antall ord:
  fil.seekg(0, ios::end);
  int antallChar = (int)fil.tellg();  
  int antallOrd = antallChar / maksOrdlengde;
  cout << "Det er " << antallOrd << " ord p filen." << endl;
  cout << "Sett opp nr. p det du vil forandre. " <<
          "Avslutt med negativt nr.: " << endl;
  int  ordnr;
  cin >> ordnr;
  while (ordnr > 0) {
    if (ordnr > antallOrd) {
      cout << "Vi har bare " << antallOrd << " ord.\n";
      cout << "Prv p nytt\n";
      } 
    else {
      char ord[maksOrdlengde];
      char nyOrd[maksOrdlengde];
      fil.seekg((ordnr - 1) * maksOrdlengde, ios::beg);  
      fil.read((char *)ord, maksOrdlengde);                      
      cout << "Gammelt ord er: " << ord << endl;
      cout << "Skriv nytt: ";
      cin >> nyOrd;
      fil.seekp((ordnr - 1) * maksOrdlengde, ios::beg);  
      fil.write((char *)nyOrd, maksOrdlengde);
      cout << "Hvis du vil forandre flere ord, skriv nummeret," << endl;
      cout << "ellers skriver du et negativt tall: " << endl;
    }
    cin >> ordnr;
  }
} // forandreOrd
