//-------------------------------------------------------------------
//
// filarg.cpp
//
// Program som demonstrerer filobjekter som argumenter
//
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

void kopierFil(istream &inn, ostream &ut);
                          
int main()
{
  // Frst lar vi de aktuelle argumentene vre datafiler:
  ifstream inn;
  ofstream ut;
  inn.open("tekstfil.dat");
  ut.open("resultat.dat");
  kopierFil(inn, ut);
  inn.close();
  ut.close();
  
  // S er de aktuelle argumentene cin og cout
  cout << "Skriv tekst : \n";
  kopierFil(cin, cout);
  return 0;
} // main

//-------------------------------------------------------------------
//
// Funksjon som kopier tekst fra inn til ut, linje for linje
//
void kopierFil(
  istream &inn,     // Inn/ut
  ostream &ut)      // Inn/ut
{
  string tekst;    
  getline(inn, tekst);
  while (!inn.eof()) {
    ut << tekst << endl;
    getline(inn, tekst);
    }
  inn.clear();
} // kopierFil
