//-------------------------------------------------------------------
//
// filfeil.cpp
//
// Program som prver ut feilfunksjonene i klassen ios
//
#include <fstream>
#include <iomanip>
#include <iostream>
#include <string>
using namespace std;
void skrivTilstand(int t, string tekst, ifstream &fil);
int main()
{
  int t;
  ifstream fil;
  fil.open("liten.dat");
  skrivTilstand(t, "Etter filpning ", fil);
  fil.clear();
  fil >> t;
  skrivTilstand(t, "Etter 1.lesing av t ", fil);
  fil.clear();
  fil >> t;
  skrivTilstand(t, "Etter 2.lesing av t ", fil);
  fil.clear();
  fil >> t;
  skrivTilstand(t, "Etter 3.lesing av t", fil);
  fil.clear();
  skrivTilstand(t, "Etter clear() ", fil);
  fil.close();
  return 0;
} // main

//-------------------------------------------------------------------
void skrivTilstand(
  int      t,       // Inn
  string   tekst,   // Inn
  ifstream &fil)    // Inn/ut
{
  const int vidde1 = 12;
  const int vidde2 = 32;
  cout << left << "t = " << setw(vidde1) << t << setw(vidde2) << tekst;
  cout << fil.good() << fil.eof()  << fil.fail() << fil.bad() << endl;
} // skrivTilstand

/* Detaljerte kjreutskrifter:

Datafilen eksisterer ikke:

t = -858993460  Etter pning av filen           0010
t = -858993460  Etter 1.lesing av t             0110
t = -858993460  Etter 2.lesing av t             0110
t = -858993460  Etter 3.lesing av t             0110
t = -858993460  Etter at clear() er kalt        1000

Datafilen eksisterer, men er tom:
t = -858993460  Etter pning av filen           1000
t = -858993460  Etter 1.lesing av t
t = -858993460  Etter 2.lesing av t             0110
t = -858993460  Etter 3.lesing av t             0110
t = -858993460  Etter at clear() er kalt        1000

Datafilen inneholder ett tall: 10
t = -858993460  Etter pning av filen           1000
t = 10          Etter 1.lesing av t             1000
t = 10          Etter 2.lesing av t             0110
t = 10          Etter 3.lesing av t             0110
t = 10          Etter at clear() er kalt        1000

Datafilen inneholder to tall: 10 20
t = -858993460  Etter pning av filen           1000
t = 10          Etter 1.lesing av t             1000
t = 20          Etter 2.lesing av t             1000
t = 20          Etter 3.lesing av t             0110
t = 20          Etter at clear() er kalt        1000

Datafilen inneholder tre tall: 10 20 30
t = -858993460  Etter pning av filen           1000
t = 10          Etter 1.lesing av t             1000
t = 20          Etter 2.lesing av t             1000
t = 30          Etter 3.lesing av t             1000
t = 30          Etter at clear() er kalt        1000
*/