//-------------------------------------------------------------------
//
// navn.cpp - implementasjonsfil
//
#include "navn.h"

//-------------------------------------------------------------------
Navn::Navn(const string &initNavn)
{
  settNavn(initNavn);
} // Navn

//-------------------------------------------------------------------
Navn::Navn(const string &initFornavn,
           const string &initMellomnavn,
           const string &initEtternavn)
    : fornavn(initFornavn),
      mellomnavn(initMellomnavn),
      etternavn(initEtternavn)
{ } // Navn

//-------------------------------------------------------------------
void Navn::settNavn(const string &nyttNavn)
{
  // Deler opp navnet i tre deler
  // Frst fornavnet
  int forsteBlank = nyttNavn.find(' ');
  fornavn = nyttNavn.substr(0, forsteBlank);

  // S mellomnavnet
  int sisteBlank = nyttNavn.rfind(' ');
  if (forsteBlank == sisteBlank) mellomnavn = "";
  else {
    int lengdeMellomnavn = sisteBlank - forsteBlank - 1;
    mellomnavn = nyttNavn.substr(forsteBlank + 1, lengdeMellomnavn);
    }

  // S etternavnet
  int lengdeEtternavn = nyttNavn.length() - sisteBlank - 1;
  etternavn = nyttNavn.substr(sisteBlank + 1, lengdeEtternavn);
} // settNavn

//-------------------------------------------------------------------
void Navn::settFornavn(const string &nyttFornavn)
{
  fornavn = nyttFornavn;
} // settFornavn

//-------------------------------------------------------------------
void Navn::settMellomnavn(const string &nyttMellomnavn)
{
  mellomnavn = nyttMellomnavn;
} // settFornavn

//-------------------------------------------------------------------
void Navn::settEtternavn(const string &nyttEtternavn)
{
  etternavn = nyttEtternavn;
} // settEtternavn

//-------------------------------------------------------------------
const string &Navn::finnFornavn() const
{
  return fornavn;
} // finnFornavn

//-------------------------------------------------------------------
const string &Navn::finnEtternavn() const
{
  return etternavn;
} // finnEtternavn

//-------------------------------------------------------------------
const string &Navn::finnMellomnavn() const
{
  return mellomnavn;
} // finnMellomnavn

//-------------------------------------------------------------------
string Navn::finnNavn() const
{
  return fornavn + " " + mellomnavn + " " + etternavn;
} // finnNavn
