//-------------------------------------------------------------------
//
// prosjektoppgave.h
//
// Definerer klassene Student og Prosjektoppgave
//
// Argument navn av typen string forutsetter at navnet 
// er p formen "fornavn (mellomnavn) etternavn".
//
#ifndef OPPGAVE_DEFINERT
  #define OPPGAVE_DEFINERT
  #include <sstream>
  #include <string>
  #include "navn.h"
  using namespace std;

  //-----------------------------------------------------------------
  //
  // Klassen Student
  // Beskriver student med navn og karakter.
  // Registrerer kun n karakter pr student. M vre i ['A','F].
  //
  class Student {
    public:
      Student(
        const string &initNavn);         // Inn
      Student(
        const Navn &initNavn);           // Inn

      void   settNavn( 
               const string &nyttNavn);  // Inn
      void   settNavn( 
               const Navn &nyttNavn);    // Inn
      bool   settKarakter(  // false hvis utenfor ['A', 'F']
               char nyKarakter);         // Inn
      
      const Navn &finnNavn() const;  
      char        finnKarakter() const;
      
      string lagUtskrift() const;

      enum konstanter {
        karakterIkkeOppgitt = '0',
        nedreKarGrense = 'A',
        ovreKarGrense = 'F'
      }; // konstanter 

    private:
      Navn navn;
      char karakter;  
  }; // Student

  //-----------------------------------------------------------------
  //
  // Klassen Prosjektoppgave
  // beskriver en student-prosjektoppgave med 
  // oppgavenr, tittel, veileder og student

  class Prosjektoppgave {   
    public:
      Prosjektoppgave( 
        int           initNr,                // Inn, oppgavenummer
        const string &initTittel,            // Inn
        const string &initStudNavn,          // Inn
        const string &initNavnVeileder);     // Inn 
      
      void settNavnStudent( 
             const string &nyttNavn);        // Inn
      void settNavnVeileder(
             const string &nyttNavn);        // Inn
      void settNavnStudent(  
             const Navn &nyttNavn);          // Inn
      void settNavnVeileder( 
             const Navn &nyttNavn);          // Inn

      bool settKarakter( 
             char nyKarakter);               // Inn
 
      int           finnNr() const;
      const string &finnTittel() const;                
      const Navn   &finnStudnavn() const;  
      const Navn   &finnVeiledernavn() const;  
      char          finnKarakter() const;

      string        lagUtskrift() const;

    private:
      int     oppgaveNr;
      string  tittel;
      Student student;
      Navn    veileder;
  }; // Prosjektoppgave
#endif
