//-------------------------------------------------------------------
//
// fjernsep.cpp
//
// Funksjon for  fjerne undige separatorer fra en tekst.
// Hovedprogrammet tester funksjonen
//
#include <iostream>
#include <cstddef>
#include <string>
using namespace std;

const int linjelengde = 81;
const int utlengde = 20;        // Liten lengde p UtTekst

void fjernSeparatorer(const char *tekst, const char *separatorer,
                      int plassAvsatt, char *omformet);

int main()
{
  char tekst[linjelengde];
  const char separatorer[] = " \n\t.,!";
  cout << "Skriv ei linje" << endl;
  cin.getline(tekst, linjelengde);
  char utTekst[utlengde];
  cout << tekst << endl;
  fjernSeparatorer(tekst, separatorer, utlengde, utTekst);
  cout << utTekst << endl;
  return 0;
} // main   

//-------------------------------------------------------------------
void fjernSeparatorer(
  const char *tekst,            // Inn
  const char *separatorer,      // Inn              
  int         plassAvsatt,      // Inn
  char       *omformet)         // Ut
{
  const char *peker1 = tekst;
  const char *peker2 = NULL;
  int         antallTegn;
  int         plassIgjen = plassAvsatt;

  omformet[0] = '\0';
  do {  
    while (*peker1 != '\0' && strchr(separatorer, *peker1)
           != NULL) peker1++;   // Hopp over separatorer

    if (*peker1 != '\0') {      // Hvis det er ord igjen
      peker2 = strpbrk(peker1, separatorer);
                                // Finn neste separator
      if (peker2 != NULL) {     // hvis den fins
        antallTegn = peker2 - peker1;
        }
      else antallTegn = strlen(peker1);
      if (plassIgjen > antallTegn + 1) {
        strncat(omformet, peker1, antallTegn);
        strcat(omformet, " ");  // En blank bak hvert ord  
        plassIgjen -= antallTegn + 1;
        peker1 = peker2;        // Flytt til neste ord
        }             
      else peker1 = NULL;       // Ikke mer plass, avslutt  
      }                                                       
    else peker1 = NULL;         // Ingen flere ord
              
  } while (peker1 != NULL);
} // fjernSeparatorer