//-------------------------------------------------------------------
//
// elevregister.cpp
//
// Implementasjon av klassen Elevregister
//

#include "elevregister.h"

//-------------------------------------------------------------------
Elevregister::Elevregister()
{ 
  maksAntElever = 3; // lite for testforml
  antElever = 0;
  elever = new Elev[maksAntElever];
} // Elevregister

//-------------------------------------------------------------------
Elevregister::Elevregister(const Elevregister &original)
{
  kopierData(original);
} // Elevregister

//-------------------------------------------------------------------
Elevregister::~Elevregister()
{
  delete [] elever;
} // ~Elevregister

//-------------------------------------------------------------------
Elevregister &Elevregister::operator=(const Elevregister &original)
{
  if (this != &original) {
    delete [] elever;
    kopierData(original);
    }  
  return *this;
} // operator=

//-------------------------------------------------------------------
void Elevregister::nyElev(const string &navn)
{
  if (antElever == maksAntElever) utvidTabell();
  elever[antElever].settNavn(navn);
  elever[antElever].settFravaer(0);
  antElever++;
} // nyElev  

//-------------------------------------------------------------------
bool Elevregister::endreFravaer(const string &navn, int endring)
{
  int indeks = finnElevIndeks(navn);
  if (indeks >= 0) {
    elever[indeks].endreFravaer(endring);
    return true;
    }
  else return false;
} // endreFravaer

//-------------------------------------------------------------------
int Elevregister::finnFravaer(const string &navn) const
{
  int indeks = finnElevIndeks(navn);
  if (indeks >= 0) return elever[indeks].finnFravaer();
  else return -1;
} // finnFravaer

//-------------------------------------------------------------------
int Elevregister::finnAntElever() const
{
  return antElever;
} // finnAntElever

//-------------------------------------------------------------------
const Elev *Elevregister::finnElev(int indeks) const
{ 
  if (indeks >= 0 && indeks < antElever) return &elever[indeks];
  else return 0;
} // finnElev

//-------------------------------------------------------------------
void Elevregister::kopierData(const Elevregister &original)
{
  maksAntElever = original.maksAntElever;
  antElever = original.antElever;
  elever = new Elev[maksAntElever];
  for (int i = 0; i < antElever; i++) {
    elever[i] = original.elever[i];
    }
} // kopierData

//-------------------------------------------------------------------
void Elevregister::utvidTabell()
{
  maksAntElever += 5;
  Elev *nyTab = new Elev[maksAntElever];
  for (int i = 0; i < antElever; i++) {
    nyTab[i] = elever[i];
    }
  delete [] elever;
  elever = nyTab;
} // utvidTabell    

//-------------------------------------------------------------------
int Elevregister::finnElevIndeks(const string &navn) const
{
  int indeks = 0;
  while (indeks < antElever && elever[indeks].finnNavn() != navn) {
    indeks++;
    }
  if (indeks < antElever) return indeks;
  else return -1;
} // finnElevIndeks