//-------------------------------------------------------------------
//
// elev.cpp
//
// Implementasjon av klassen Elev
//

#include "elev.h"

//-------------------------------------------------------------------
Elev::Elev()
    : navn(""),
      fravaer(0)
{ } // Elev

//-------------------------------------------------------------------
Elev::Elev(const string &initNavn)
    : navn(initNavn), 
      fravaer(0)   
{ } // Elev     

//-------------------------------------------------------------------
void Elev::settFravaer(int nyttFravaer)
{
  fravaer = nyttFravaer;
} // settFravaer

//-------------------------------------------------------------------
void Elev::settNavn(const string &nyttNavn)
{
  navn = nyttNavn;
} // settNavn

//-------------------------------------------------------------------
void Elev::endreFravaer(int endring)
{
  fravaer += endring;
} // endreFravaer

//-------------------------------------------------------------------
int Elev::finnFravaer() const
{
  return fravaer;
} // finnFravaer

//-------------------------------------------------------------------
const string &Elev::finnNavn() const
{ 
  return navn;
} // finnNavn

//-------------------------------------------------------------------
bool Elev::operator==(const Elev &denAndre) const
{
  return (navn == denAndre.navn);
} // operator==
  
//-------------------------------------------------------------------  
bool Elev::operator<(const Elev &denAndre) const
{
  return (navn < denAndre.navn);
} // operator <
  
//-------------------------------------------------------------------  
ostream &operator<<(ostream &ut, const Elev &eleven)
{
  cout << eleven.finnNavn() << " har " << 
          eleven.finnFravaer() << " dager fravr.";
  return ut;
} // operator <<
   