//-------------------------------------------------------------------
//
// elevregister.cpp
//
// Implementasjon av klassen Elevregister
//
#include <algorithm>
#include "elevregister.h"

//-------------------------------------------------------------------
void Elevregister::nyElev(const string &navn)
{
  Elev nyElev(navn);
  elever.push_back(nyElev);
} // nyElev

//-------------------------------------------------------------------
bool Elevregister::endreFravaer(const string &navn, int endring)
{
  Elev elev(navn);
  vector<Elev>::iterator eleven = 
                         find(elever.begin(), elever.end(), elev);
  if (eleven < elever.end()) {
    eleven->endreFravaer(endring);
    return true;
    }
  else return false;
} // endreFravaer

//-------------------------------------------------------------------
int Elevregister::finnFravaer(const string &navn) const
{
  Elev elev(navn);
  vector<Elev>::const_iterator eleven = 
                      find(elever.begin(), elever.end(), elev);
  if (eleven < elever.end()) return eleven->finnFravaer();
  else return -1;
} // finnFravaer

//-------------------------------------------------------------------
int Elevregister::finnAntElever() const
{
  return elever.size();
} // finnAntElever

//-------------------------------------------------------------------
const Elev *Elevregister::finnElev(int indeks) const
{ 
  if (indeks >= 0 && indeks < elever.size()) return &elever[indeks];
  else return 0;
} // finnElev