//-------------------------------------------------------------------
//
// nytte.h
//
// Funksjoner som letter kommunikasjonen med inn- og ut-enhet. 
//
#include <string>
using namespace std;
#ifndef NYTTE_DEFINERT
  #define NYTTE_DEFINERT

  //-------------------------------------------------------------------
  //
  // Funksjonen leser ei linje med tekst, fram til og med linjeskift.
  // Dersom filpekeren str p slutten av forrige linje 
  // (f.eks. dersom >> er brukt), flyttes den til begynnelsen av 
  // neste linje fr lesing.
  string lesLinje(
    istream &inn);   // Inn/ut   fil eller cin

  //-------------------------------------------------------------------
  //
  // Funksjon for  skrive et flyttall med et bestemt antall desimaler
  // og en bestemt feltvidde. 
  // Tallet skrives p fast (ikke eksponensielt) format
  //
  void skrivFlyttall(
    ostream &ut,           // Inn/ut   fil eller cout
    double   tall,         // Inn
    int      presisjon,    // Inn
    int      feltvidde);   // Inn

  //-------------------------------------------------------------------
  //
  // Funksjon som skriver en menytekst p skjermen, 
  // og leser brukers valg. Hvis bruker skriver et ulovlig tegn, 
  // ber funksjonen om et nytt tegn.
  // Bde stor og liten bokstav godtas.
  // Returverdien forteller hvilket tegnnummer som ble valgt.
  //                 
  int lesMenyvalg(
    string menytekst,    // Inn
    string lovligValg);  // Inn  
    
  //-------------------------------------------------------------------
  //
  // Funksjon som leser et tall fra bruker. Tallet m ligge i det 
  // lukkede intervallet [nedre, ovre]. Grensene byttes om dersom nedre
  // er strre enn ovre. Funksjonen gr i lkke inntil gyldig
  // svar fra bruker. Tallet returneres. Programmet som bruker 
  // funskjonen m skrive ledeteksten til skjermen.
  //                    
  int lesTallIIntervall(
    int nedre,          // Inn
    int ovre);          // Inn
    
  //-------------------------------------------------------------------    
  //
  // Avslutter programutfrelsen. Alle filer lukkes.
  //
  void avsluttMedFeilmelding(
    string tekst);    // Inn    

#endif
