//-------------------------------------------------------------------
//
// testFravaer.cpp
//
// Et menystyrt program for  administrere fravret
// til elevene i en klasse.
//
#include <iostream>
#include "elevregister.h"
#include "nytte.h"

const string menytekst = "N: Ny elev.\n"
                         "E: Endre fravret for en elev.\n"
                         "S: Skriv ut oversikt over alle elevene.\n"
                         "A: Avslutt.\n";
const string lovligValg = "NESA";
enum valg {nyElev, endreFravaer, skrivUt, avslutt};

void utfoerValg(valg valget, Elevregister &registeret);

int main()
{
  Elevregister fravaeret;
  valg valget = (valg) lesMenyvalg(menytekst, lovligValg);
  while (valget != avslutt) {
    utfoerValg(valget, fravaeret);
    valget = (valg)lesMenyvalg(menytekst, lovligValg);
  } // while
  return 0;
} // main

//-------------------------------------------------------------------
//
// Vedlikeholder fravrsregisteret.
//
void utfoerValg(
  valg     valget,        // Inn
  Elevregister &registeret)       // Inn/ut
{
  switch (valget) {
    case nyElev: {
      cout << "Oppgi navn: ";
      string navn = lesLinje(cin);  // fra nytte.h
      registeret.nyElev(navn);
      cout << "Ny elev registrert.\n";
      } // case
      break;
    case endreFravaer: {
      cout << "Elevens navn: ";
      string navn = lesLinje(cin);
      int dager;
      cout << "Oppgi endring i fravret: ";
      cin >> dager;
      if (registeret.endreFravaer(navn, dager)) {
        cout << "Ok. N er fravret for denne eleven " <<
                registeret.finnFravaer(navn) << " dager.\n";
        }
      else cout << "Ingen elev med dette navnet.\n";
      } // case
      break;
    case skrivUt: {
      cout << "\nAlle elevene:\n";
      for (int indeks = 0; indeks < registeret.finnAntElever();
                                                     indeks++) {
        const Elev *eleven = registeret.finnElev(indeks);
        cout << "Elev nr: " << (indeks + 1) << ", " <<
                 eleven->finnNavn() << " har " <<
                 eleven->finnFravaer() << " dager fravr.\n";
        } // for
        cout << endl;
      } // case
      break;
    default:
      break;
    } // switch
} // utfoerValg
