//-------------------------------------------------------------------
//
// maaler.h
//
// Klasser for hndtering av vrdata.
//
#ifndef MAALER_DEFINERT
  #define MAALER_DEFINERT
  class Maaler {
    public:
      void         settNr(
                     int nyttNr);              // Inn
      void         settPosisjon(
                     int nyPosisjon);          // Inn
      int          finnNr() const;
      int          finnPosisjon() const;
      virtual void skrivData() const = 0;

    protected:
      void skrivFelles() const;

    private:
      int nr;
      int posisjon;
    }; // Maaler

  //-----------------------------------------------------------------
  class Barometer: public Maaler {
    public:
      void         settTrykk(
                     double nyttTrykk);        // Inn, kPa
      double       finnTrykk() const;
      virtual void skrivData() const;

    private:
      double trykk;
    }; // Barometer

  //-----------------------------------------------------------------
  class Termometer: public Maaler {
    public:
      void         settTemperatur(
                     double nyTemperatur);     // Inn, Celsius
      double       finnTemperatur() const;
      virtual void skrivData() const;

    private:
      double temperatur;
    }; // Termometer

  //-----------------------------------------------------------------
  class Vindmaaler: public Maaler {
    public:
      void        settVind(
                    double retning,            // Inn, grader
                    double hastighet);         // Inn, m/s
      void        finnVind(
                    double &retning,           // Ut
                    double &hastighet) const;  // Ut
      virtual void skrivData() const;

    private:
      double retning;
      double hastighet;
    }; // Vindmaaler
#endif
