//-------------------------------------------------------------------
//
// stringStream.cpp
//
// Lager en utskrift som inneholder vareinformasjon.
// 

#include <string>
#include <sstream>
#include <iostream>  
#include <iomanip>
using namespace std;           

string lagUtskrift(int varenr, string varenavn, double pris);

int main()
{                          
  string utskrift = lagUtskrift(100, "Skriveblokk", 21.5);
  cout << utskrift;  // Prver utskriften
  return 0;
} // main  

//-------------------------------------------------------------------
//
// Konstruerer en streng som inneholder formatert vareinformasjon
//
string lagUtskrift(
  int    varenr,            // Inn
  string varenavn,          // Inn
  double pris)              // Inn, skal skrives ut med 2 desimaler
{
  ostringstream utskrift;     
  utskrift.setf(ios::fixed, ios::floatfield); 
  utskrift << "Varenr: " << varenr << endl;
  utskrift << "Navn:   " << varenavn << endl;
  utskrift << "Pris:   " << "kr. " << setprecision(2) << 
               showpoint << pris << endl;  

  return utskrift.str();
} // lagUtskrift
