//--------------------------------------------------------------------
//
// laan.cpp
//
// Program for  beregne renter og avdrag av et annuitetsln
//
#include <iostream>
#include <string>
#include <iomanip>
using namespace std;
const int vidde = 10;
const int presisjon = 2;
void   skrivOverskrift(string tekst);
double beregnRente(double laaneBeloep, double rentefot);
double beregnAvdrag(double terminBeloep, double rente);
double beregnNyttLaan(double laaneBeloep, double avdrag);
void   skrivFlyttall(double tall, int presisjon, int feltvidde);

int main()
{
  double laanebeloep;
  double rentefot;
  double terminbeloep;

  cout << "Lnebelp? ";
  cin >> laanebeloep;
  cout << "Rente i prosent? ";
  cin >> rentefot;
  cout << "Terminbelp? ";
  cin >> terminbeloep;

  skrivOverskrift("     Rente   Avdrag   Nytt ln");

  while (laanebeloep > 0.0) {
    double rente = beregnRente(laanebeloep, rentefot);
    double avdrag = beregnAvdrag(terminbeloep, rente);
    laanebeloep = beregnNyttLaan(laanebeloep, avdrag);
    skrivFlyttall(rente, presisjon, vidde);
    skrivFlyttall(avdrag, presisjon, vidde);
    skrivFlyttall(laanebeloep, presisjon, vidde);
    cout << endl;
    }
  return 0;
} // main

//--------------------------------------------------------------------
//
// Skriver overskrift med strek under.
//
void skrivOverskrift(
  string tekst)          // Inn: Overskrifta
{
  cout << endl;
  cout << tekst << endl;
  int lengde = tekst.length();
  string strek = string(lengde, '-');
  cout << strek << endl;
} // skrivOverskrift

//--------------------------------------------------------------------
//
// Beregner rente ved formelen rente = laanebeloep * rentefot / 100
//
double beregnRente(
  double laanebeloep,   // Inn
  double rentefot)      // Inn
{
  return laanebeloep * rentefot / 100.0;
} // beregnRente

//--------------------------------------------------------------------
//
// Beregner avdrag ved formelen avdrag = terminbeloep - rente
//
double beregnAvdrag(
  double terminbeloep,  // Inn
  double rente)         // Inn
{
  return terminbeloep - rente;
} // beregnAvdrag

//--------------------------------------------------------------------
//
// Beregner nytt ln ved formelen nyttLaan = laanebeloep - avdrag
//
double beregnNyttLaan(
  double laanebeloep,   // Inn
  double avdrag)        // Inn
{
  return laanebeloep - avdrag;
} // beregnNyttLaan

//--------------------------------------------------------------------
//
// Funksjon for  skrive et heltall med et bestemt antall desimaler
// og en bestemt feltvidde
//
void skrivFlyttall(
  double tall,        // Inn
  int    presisjon,   // Inn
  int    feltvidde)   // Inn
{
  cout.setf(ios::fixed, ios::floatfield); 
  cout << setprecision(presisjon);
  cout << setw(feltvidde) << tall;
  cout << setprecision(6);
  cout.setf(0, ios::floatfield);
} // skrivFlyttall

