//--------------------------------------------------------------------
//
// trekant.cpp
//
// Programmet beregner arealet av trekant eller sirkel avhengig av
// brukers nske
//
#include <iostream>
#include <cctype>
using namespace std;

const double pi = 3.141592;
const char   trekant = 'T';
const char   sirkel  = 'S';

char   lesValg();
double beregnAreal(char valg);
void   skrivAreal(double areal);
void   lesDataForTrekant(double &grunnlinje, double &hoyde);
double beregnArealForTrekant(double grunnlinje, double hoyde);
void   lesDataForSirkel(double &radius);
double beregnArealForSirkel(double radius);
char   lesLovligSvar(char lovlig1, char lovlig2);                                              
                                              
int main()
{
  char   valg = lesValg();
  double areal = beregnAreal(valg);
  skrivAreal(areal);
  return 0;
} // main

//--------------------------------------------------------------------
//
// Leser inn brukerens nske - trekant eller sirkel
//
char lesValg()
{
  cout << "nsker du  behandle trekant eller sirkel?" << endl;
  cout << "Skriv " << trekant << " for trekant og  "
       << sirkel << " for sirkel: ";
  char valg = lesLovligSvar(trekant, sirkel);
  return valg;
} // lesValg

//--------------------------------------------------------------------
//
// Behandler figurene
//
double beregnAreal(
  char valg)              // Inn: trekant eller sirkel
{
  double areal;
  if (valg == trekant) {
    double grunnlinje;
    double hoyde;
    lesDataForTrekant(grunnlinje, hoyde);
    areal = beregnArealForTrekant(grunnlinje, hoyde);
    }
  else {
    double radius;
    lesDataForSirkel(radius);
    areal = beregnArealForSirkel(radius);
    }
  return areal;
} // beregnAreal

//--------------------------------------------------------------------
//
// Skriver ut arealet
//
void skrivAreal(
  double areal)           // Inn
{
  cout << "Arealet blir: " << areal << endl;
} // skrivAreal

//--------------------------------------------------------------------
//
// Leser grunnlinje og hyde
//
void lesDataForTrekant(
  double &grunnlinje,     // Ut
  double &hoyde)          // Ut
{                        
  cout << "Skriv grunnlinje og hyde: ";
  cin >> grunnlinje >> hoyde ;
} // lesDataForTrekant

//--------------------------------------------------------------------
//
// Beregner arealet av en trekant
//
double beregnArealForTrekant(
  double grunnlinje,      // Inn
  double hoyde)           // Inn
{
  return 0.5 * grunnlinje * hoyde;
} // beregnArealForTrekant

//--------------------------------------------------------------------
//
// Leser inn radius
//
void lesDataForSirkel(
  double &radius)         // Ut
{
  cout << "Skriv radius: ";
  cin >> radius;
} // lesDataForSirkel

//--------------------------------------------------------------------
//
// Beregner arealet av en sirkel
//
double beregnArealForSirkel(
  double radius)          // Inn
{
  return pi * radius * radius;
} // beregnArealForSirkel

//-------------------------------------------------------------------
//
// Funksjonen leser inn en bokstav fra brukeren.
// Bokstaven m vre enten stor eller liten utgave av argumentene.
//
char lesLovligSvar(
  char lovlig1,     // Inn
  char lovlig2)     // Inn
{                         
  lovlig1 = toupper(lovlig1);
  lovlig2 = toupper(lovlig2);
  char lovlig1Liten = tolower(lovlig1);
  char lovlig2Liten = tolower(lovlig2);
  char svar;
  cin >> svar;
  svar = toupper(svar);
  while (svar != lovlig1 && svar != lovlig2) {
    cout << "Feil! Skriv " << lovlig1 << ", " << lovlig1Liten
      << ", " << lovlig2 << " eller " << lovlig2Liten << " : ";
    cin >> svar;                      
    svar = toupper(svar);
    }  // behandling av feil inntasting fra bruker
  return svar;
} // lesLovligSvar
