//-------------------------------------------------------------------
//
// potens.cpp
//
// Program som definerer en potensberegningsfunksjon, og tester den.
//
#include <iostream>
using namespace std;

const int    testomraade = 5;
const double eps = 1.0E-10;

bool beregnPotens(double x, int n, double &svar);

int main()
{
  double x;
  double svar;

  cout << "Velg grunntall x: ";
  cin  >> x;
  int teller;
  for (teller = testomraade; teller >= -testomraade; teller--) {
    if (beregnPotens(x, teller, svar)) {
      cout << "x = " << x << " n = " << teller << " Svar = " << svar;
      }
    else {
      cout << "x = " << x << " og n = " << teller << " er umulig. ";
      }
    cout << endl;
    }
  return 0;
} // main

//-------------------------------------------------------------------
//
// Beregner x opphyd i n'te potens for de x og n-verdier dette er
// definert. Returnerer i s fall true som funksjonsverdi.
// Nr potensen ikke er definert, returneres false.
//
bool beregnPotens(
  double  x,            // Inn: Grunntall
  int     n,            // Inn: Eksponent
  double &svar)         // Ut
{
  bool positivN = n > 0;
  bool ok;
  if ( x < eps && x > -eps) { // x tilnrmet lik 0
    if (positivN) {
      svar = 0.0;
      ok = true;
      }
    else ok = false;
    }
  else {
    if (!positivN) n = -n;
    svar = 1.0;

    int teller;
    for (teller = 0; teller < n; teller++) svar *= x;
    if (!positivN) svar = 1.0 / svar;
    ok = true;
    }
  return ok;
} // potensBeregnet
